#===============================================================================
# Copyright 2014-2017 Intel Corporation All Rights Reserved.
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#===============================================================================

## <a name="DAAL-EXAMPLE-PY-PCA_CORRELATION_CSR_ONLINE"></a>
## \example pca_cor_csr_online.py

from os import environ
from os.path import join as jp

from daal.algorithms.covariance import Online_Float64FastCSR
from daal.algorithms.pca import (
    Online_Float64CorrelationDense, data, eigenvalues, eigenvectors
)
import inspect, sys, os.path
utils_folder = os.path.realpath(os.path.abspath(jp(os.path.split(inspect.getfile(inspect.currentframe()))[0], "..")))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printNumericTable, createSparseTable

DAAL_PREFIX = jp('..', 'data')

# Input data set parameters
nBlocks = 4
datasetFileNames = [
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_1.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_2.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_3.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_4.csv')
]

if __name__ == "__main__":

    # Create an algorithm for principal component analysis using the correlation method
    algorithm = Online_Float64CorrelationDense()

    # Use covariance algorithm for sparse data inside the PCA algorithm
    algorithm.parameter.covariance = Online_Float64FastCSR()

    for i in range(nBlocks):
        # Read data from a file and create a numeric table to store input data
        dataTable = createSparseTable(datasetFileNames[i])

        # Set input objects for the algorithm
        algorithm.input.setDataset(data, dataTable)

        # Update PCA decomposition
        algorithm.compute()

    # Finalize computations
    result = algorithm.finalizeCompute()

    printNumericTable(result.get(eigenvalues), "Eigenvalues:")
    printNumericTable(result.get(eigenvectors), "Eigenvectors:")
